'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lib = require('../../lib/');

var _BootButton = require('../BootButton');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  tag: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),
  child: _propTypes2.default.node,
  groupClassName: _propTypes2.default.string,
  groupAttributes: _propTypes2.default.object,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object
};

var defaultProps = {
  tag: 'div'
};

var InputGroupButton = function InputGroupButton(props) {
  var className = props.className,
      cssModule = props.cssModule,
      Tag = props.tag,
      child = props.child,
      groupClassName = props.groupClassName,
      groupAttributes = props.groupAttributes,
      attributes = (0, _objectWithoutProperties3.default)(props, ['className', 'cssModule', 'tag', 'child', 'groupClassName', 'groupAttributes']);


  if (typeof child === 'string') {
    var groupClasses = (0, _lib.mapToCssModules)((0, _classnames2.default)(groupClassName, 'input-group-btn'), cssModule);

    return _react2.default.createElement(
      Tag,
      (0, _extends3.default)({}, groupAttributes, { className: groupClasses }),
      _react2.default.createElement(_BootButton.BootButton, (0, _extends3.default)({}, attributes, { className: className, child: child }))
    );
  }

  var classes = (0, _lib.mapToCssModules)((0, _classnames2.default)(className, 'input-group-btn'), cssModule);

  return _react2.default.createElement(Tag, (0, _extends3.default)({}, attributes, { className: classes, child: child }));
};

InputGroupButton.handledProps = [];
InputGroupButton.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
InputGroupButton.defaultProps = defaultProps;

exports.default = InputGroupButton;