'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactTransitionGroup = require('react-transition-group');

var _lib = require('../../lib/');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Carousel = function (_React$Component) {
  (0, _inherits3.default)(Carousel, _React$Component);

  function Carousel(props) {
    (0, _classCallCheck3.default)(this, Carousel);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Carousel.__proto__ || Object.getPrototypeOf(Carousel)).call(this, props));

    _this.handleKeyPress = _this.handleKeyPress.bind(_this);
    _this.state = { direction: 'right' };
    return _this;
  }

  (0, _createClass3.default)(Carousel, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return { direction: this.state.direction };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      // Set up the cycle
      if (this.props.interval) {
        this.cycleInterval = setInterval(function () {
          if (!_this2.props.paused) {
            _this2.props.next();
          }
        }, parseInt(this.props.interval, 10));
      }

      if (this.props.keyboard) {
        document.addEventListener('keyup', this.handleKeyPress);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // Calculate the direction to turn
      if (this.props.activeIndex + 1 === nextProps.activeIndex) {
        this.setState({ direction: 'right' });
      } else if (this.props.activeIndex - 1 === nextProps.activeIndex) {
        this.setState({ direction: 'left' });
      } else if (this.props.activeIndex > nextProps.activeIndex) {
        this.setState({ direction: 'right' });
      } else {
        this.setState({ direction: 'left' });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(this.cycleInterval);
      document.removeEventListener('key', this.handleKeyPress);
    }
  }, {
    key: 'handleKeyPress',
    value: function handleKeyPress(evt) {
      if (this.props.keyboard && evt.keyCode === 37) {
        this.props.previous();
      } else if (this.props.keyboard && evt.keyCode === 39) {
        this.props.next();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          children = _props.children,
          cssModule = _props.cssModule,
          activeIndex = _props.activeIndex,
          hoverStart = _props.hoverStart,
          hoverEnd = _props.hoverEnd;

      var outerClasses = (0, _lib.mapToCssModules)((0, _classnames2.default)('carousel', 'slide'), cssModule);

      var innerClasses = (0, _lib.mapToCssModules)((0, _classnames2.default)('carousel-inner'), cssModule);

      var slidesOnly = children.every(function (child) {
        return child.type && child.type.name === 'CarouselItem';
      });

      // Rendering only slides
      if (slidesOnly) {
        return _react2.default.createElement(
          'div',
          { className: outerClasses, onMouseEnter: hoverStart, onMouseLeave: hoverEnd },
          _react2.default.createElement(
            _reactTransitionGroup.TransitionGroup,
            { component: 'div', role: 'listbox', className: innerClasses },
            children[activeIndex]
          )
        );
      }

      // Rendering slides and controls
      if (children[0] instanceof Array) {
        var _carouselItems = children[0];
        var _controlLeft = children[1];
        var _controlRight = children[2];

        return _react2.default.createElement(
          'div',
          { className: outerClasses, onMouseEnter: hoverStart, onMouseLeave: hoverEnd },
          _react2.default.createElement(
            _reactTransitionGroup.TransitionGroup,
            { component: 'div', role: 'listbox', className: innerClasses },
            _carouselItems[activeIndex]
          ),
          _controlLeft,
          _controlRight
        );
      }

      // Rendering indicators, slides and controls
      var indicators = children[0];
      var carouselItems = children[1];
      var controlLeft = children[2];
      var controlRight = children[3];

      return _react2.default.createElement(
        'div',
        {
          ref: function ref(carousel) {
            _this3.carousel = carousel;
          },
          className: outerClasses,
          onMouseEnter: hoverStart,
          onMouseLeave: hoverEnd
        },
        indicators,
        _react2.default.createElement(
          _reactTransitionGroup.TransitionGroup,
          { component: 'div', role: 'listbox', className: innerClasses },
          carouselItems[activeIndex]
        ),
        controlLeft,
        controlRight
      );
    }
  }]);
  return Carousel;
}(_react2.default.Component);

Carousel.handledProps = ['activeIndex', 'children', 'cssModule', 'hover', 'hoverEnd', 'hoverStart', 'interval', 'keyboard', 'next', 'paused', 'previous'];


Carousel.propTypes = process.env.NODE_ENV !== "production" ? {
  paused: _propTypes2.default.bool,
  next: _propTypes2.default.func.isRequired,
  previous: _propTypes2.default.func.isRequired,
  keyboard: _propTypes2.default.bool,
  cssModule: _propTypes2.default.object,
  activeIndex: _propTypes2.default.number,
  interval: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.bool]),
  children: _propTypes2.default.array,
  hoverStart: _propTypes2.default.func,
  hoverEnd: _propTypes2.default.func,
  hover: _propTypes2.default.bool
} : {};

Carousel.defaultProps = {
  interval: 5000,
  hover: false,
  paused: false,
  keyboard: true
};

Carousel.childContextTypes = {
  direction: _propTypes2.default.string
};

exports.default = Carousel;