'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lib = require('../../lib/');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CarouselCaption = function CarouselCaption(props) {
  var captionHeader = props.captionHeader,
      captionText = props.captionText,
      cssModule = props.cssModule;

  var classes = (0, _lib.mapToCssModules)((0, _classnames2.default)('carousel-caption', 'd-none', 'd-md-block'), cssModule);

  return _react2.default.createElement(
    'div',
    { className: classes },
    _react2.default.createElement(
      'h3',
      null,
      captionHeader
    ),
    _react2.default.createElement(
      'p',
      null,
      captionText
    )
  );
};

CarouselCaption.handledProps = ['captionHeader', 'captionText', 'cssModule'];
CarouselCaption.propTypes = process.env.NODE_ENV !== "production" ? {
  captionHeader: _propTypes2.default.string,
  captionText: _propTypes2.default.string.isRequired,
  cssModule: _propTypes2.default.object
} : {};

exports.default = CarouselCaption;