'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lib = require('../../lib/');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable jsx-a11y/interactive-supports-focus */
var CarouselControl = function CarouselControl(props) {
  var direction = props.direction,
      onClickHandler = props.onClickHandler,
      cssModule = props.cssModule,
      directionText = props.directionText;


  var anchorClasses = (0, _lib.mapToCssModules)((0, _classnames2.default)('carousel-control-' + direction), cssModule);

  var iconClasses = (0, _lib.mapToCssModules)((0, _classnames2.default)('carousel-control-' + direction + '-icon'), cssModule);

  var screenReaderClasses = (0, _lib.mapToCssModules)((0, _classnames2.default)('sr-only'), cssModule);

  return _react2.default.createElement(
    'a',
    {
      className: anchorClasses,
      role: 'button',
      onClick: function onClick(e) {
        e.preventDefault();
        onClickHandler();
      }
    },
    _react2.default.createElement('span', { className: iconClasses, 'aria-hidden': 'true' }),
    _react2.default.createElement(
      'span',
      { className: screenReaderClasses },
      directionText || direction
    )
  );
};

CarouselControl.handledProps = ['cssModule', 'direction', 'directionText', 'onClickHandler'];
CarouselControl.propTypes = process.env.NODE_ENV !== "production" ? {
  direction: _propTypes2.default.oneOf(['prev', 'next']).isRequired,
  onClickHandler: _propTypes2.default.func.isRequired,
  cssModule: _propTypes2.default.object,
  directionText: _propTypes2.default.string
} : {};

exports.default = CarouselControl;