'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lib = require('../../lib/');

var _BootCarouselCaption = require('./BootCarouselCaption');

var _BootCarouselCaption2 = _interopRequireDefault(_BootCarouselCaption);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CarouselItem = function (_React$Component) {
  (0, _inherits3.default)(CarouselItem, _React$Component);

  function CarouselItem(props) {
    (0, _classCallCheck3.default)(this, CarouselItem);

    var _this = (0, _possibleConstructorReturn3.default)(this, (CarouselItem.__proto__ || Object.getPrototypeOf(CarouselItem)).call(this, props));

    _this.state = { animation: [] };
    return _this;
  }

  (0, _createClass3.default)(CarouselItem, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.willEnterTimeout);
      clearTimeout(this.willLeaveTimeout);
    }
  }, {
    key: 'componentWillAppear',
    value: function componentWillAppear(callBack) {
      this.setState({
        animation: ['active']
      });
      callBack();
    }
  }, {
    key: 'componentWillEnter',
    value: function componentWillEnter(callBack) {
      var classes = this.context.direction === 'right' ? ['carousel-item-next', 'carousel-item-left'] : ['carousel-item-prev', 'carousel-item-right'];
      this.setState({
        animation: classes
      });

      this.willEnterTimeout = setTimeout(function () {
        callBack();
      }, 500);
    }
  }, {
    key: 'componentDidEnter',
    value: function componentDidEnter() {
      this.setState({
        animation: ['active']
      });
    }
  }, {
    key: 'componentWillLeave',
    value: function componentWillLeave(callBack) {
      var classes = this.context.direction === 'right' ? ['carousel-item-left', 'active'] : ['carousel-item-right', 'active'];
      this.setState({
        animation: classes
      });

      this.slide.dispatchEvent(new CustomEvent('slide.bs.carousel'));

      this.willLeaveTimeout = setTimeout(function () {
        callBack();
      }, 500);
    }
  }, {
    key: 'componentDidLeave',
    value: function componentDidLeave() {
      this.setState({
        animation: []
      });
      this.slide.dispatchEvent(new CustomEvent('slid.bs.carousel'));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          src = _props.src,
          altText = _props.altText,
          children = _props.children,
          cssModule = _props.cssModule;

      var classes = (0, _lib.mapToCssModules)((0, _classnames2.default)('d-block', 'img-fluid'), cssModule);

      var itemClasses = (0, _lib.mapToCssModules)(_classnames2.default.apply(undefined, ['carousel-item'].concat((0, _toConsumableArray3.default)(this.state.animation))), cssModule);

      return _react2.default.createElement(
        'div',
        { className: itemClasses, ref: function ref(slide) {
            _this2.slide = slide;
          } },
        _react2.default.createElement('img', { className: classes, src: src, alt: altText }),
        children
      );
    }
  }]);
  return CarouselItem;
}(_react2.default.Component);

CarouselItem.handledProps = ['altText', 'children', 'cssModule', 'src'];


CarouselItem.propTypes = process.env.NODE_ENV !== "production" ? {
  src: _propTypes2.default.string.isRequired,
  altText: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  children: _propTypes2.default.instanceOf(_BootCarouselCaption2.default)
} : {};

CarouselItem.contextTypes = {
  direction: _propTypes2.default.string
};

exports.default = CarouselItem;