import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var propTypes = {
  tag: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),
  className: PropTypes.any
};

var defaultProps = {
  tag: 'p'
};

var ListGroupItemText = function ListGroupItemText(props) {
  var className = props.className,
      Tag = props.tag,
      attributes = _objectWithoutProperties(props, ['className', 'tag']);

  var classes = cx(className, 'list-group-item-text');

  return React.createElement(Tag, _extends({}, attributes, { className: classes }));
};

ListGroupItemText.handledProps = [];
ListGroupItemText.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
ListGroupItemText.defaultProps = defaultProps;

export default ListGroupItemText;