import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { mapToCssModules } from '../../lib/';
import { BootButton } from '../BootButton';

var propTypes = {
  tag: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),
  child: PropTypes.node,
  groupClassName: PropTypes.string,
  groupAttributes: PropTypes.object,
  className: PropTypes.string,
  cssModule: PropTypes.object
};

var defaultProps = {
  tag: 'div'
};

var InputGroupButton = function InputGroupButton(props) {
  var className = props.className,
      cssModule = props.cssModule,
      Tag = props.tag,
      child = props.child,
      groupClassName = props.groupClassName,
      groupAttributes = props.groupAttributes,
      attributes = _objectWithoutProperties(props, ['className', 'cssModule', 'tag', 'child', 'groupClassName', 'groupAttributes']);

  if (typeof child === 'string') {
    var groupClasses = mapToCssModules(cx(groupClassName, 'input-group-btn'), cssModule);

    return React.createElement(
      Tag,
      _extends({}, groupAttributes, { className: groupClasses }),
      React.createElement(BootButton, _extends({}, attributes, { className: className, child: child }))
    );
  }

  var classes = mapToCssModules(cx(className, 'input-group-btn'), cssModule);

  return React.createElement(Tag, _extends({}, attributes, { className: classes, child: child }));
};

InputGroupButton.handledProps = [];
InputGroupButton.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
InputGroupButton.defaultProps = defaultProps;

export default InputGroupButton;