import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { mapToCssModules } from '../../lib/';
import CarouselCaption from './BootCarouselCaption';

var CarouselItem = function (_React$Component) {
  _inherits(CarouselItem, _React$Component);

  function CarouselItem(props) {
    _classCallCheck(this, CarouselItem);

    var _this = _possibleConstructorReturn(this, (CarouselItem.__proto__ || Object.getPrototypeOf(CarouselItem)).call(this, props));

    _this.state = { animation: [] };
    return _this;
  }

  _createClass(CarouselItem, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.willEnterTimeout);
      clearTimeout(this.willLeaveTimeout);
    }
  }, {
    key: 'componentWillAppear',
    value: function componentWillAppear(callBack) {
      this.setState({
        animation: ['active']
      });
      callBack();
    }
  }, {
    key: 'componentWillEnter',
    value: function componentWillEnter(callBack) {
      var classes = this.context.direction === 'right' ? ['carousel-item-next', 'carousel-item-left'] : ['carousel-item-prev', 'carousel-item-right'];
      this.setState({
        animation: classes
      });

      this.willEnterTimeout = setTimeout(function () {
        callBack();
      }, 500);
    }
  }, {
    key: 'componentDidEnter',
    value: function componentDidEnter() {
      this.setState({
        animation: ['active']
      });
    }
  }, {
    key: 'componentWillLeave',
    value: function componentWillLeave(callBack) {
      var classes = this.context.direction === 'right' ? ['carousel-item-left', 'active'] : ['carousel-item-right', 'active'];
      this.setState({
        animation: classes
      });

      this.slide.dispatchEvent(new CustomEvent('slide.bs.carousel'));

      this.willLeaveTimeout = setTimeout(function () {
        callBack();
      }, 500);
    }
  }, {
    key: 'componentDidLeave',
    value: function componentDidLeave() {
      this.setState({
        animation: []
      });
      this.slide.dispatchEvent(new CustomEvent('slid.bs.carousel'));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          src = _props.src,
          altText = _props.altText,
          children = _props.children,
          cssModule = _props.cssModule;

      var classes = mapToCssModules(cx('d-block', 'img-fluid'), cssModule);

      var itemClasses = mapToCssModules(cx.apply(undefined, ['carousel-item'].concat(_toConsumableArray(this.state.animation))), cssModule);

      return React.createElement(
        'div',
        { className: itemClasses, ref: function ref(slide) {
            _this2.slide = slide;
          } },
        React.createElement('img', { className: classes, src: src, alt: altText }),
        children
      );
    }
  }]);

  return CarouselItem;
}(React.Component);

CarouselItem.handledProps = ['altText', 'children', 'cssModule', 'src'];


CarouselItem.propTypes = process.env.NODE_ENV !== "production" ? {
  src: PropTypes.string.isRequired,
  altText: PropTypes.string,
  cssModule: PropTypes.object,
  children: PropTypes.instanceOf(CarouselCaption)
} : {};

CarouselItem.contextTypes = {
  direction: PropTypes.string
};

export default CarouselItem;