import React from 'react'
import PropTypes from 'prop-types'
import cx from 'classnames'

const propTypes = {
  tag: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),
  className: PropTypes.any,
}

const defaultProps = {
  tag: 'h5',
}

const ListGroupItemHeading = (props) => {
  const {
    className,
    tag: Tag,
    ...attributes
  } = props
  const classes = cx(
    className,
    'list-group-item-heading',
  )

  return (
    <Tag {...attributes} className={classes} />
  )
}

ListGroupItemHeading.propTypes = propTypes
ListGroupItemHeading.defaultProps = defaultProps

export default ListGroupItemHeading
